defmodule Nulla.Models.Activity do
  use Ecto.Schema
  import Ecto.Changeset

  schema "activities" do
    field :type, :string
    field :actor, :string
    field :object, :map
    field :cc, {:array, :string}, default: []

    timestamps()
  end

  @doc false
  def changeset(activity, attrs) do
    activity
    |> cast(attrs, [:type, :actor, :object, :to])
    |> validate_required([:type, :actor, :object])
    |> validate_inclusion(:type, ~w(Create Update Delete Undo Like Announce Follow Accept Reject))
  end
end
